﻿#ifndef _VPOUT_H_
#define _VPOUT_H_

#include "memory_nvcom02_t.h"
#include "target.h"

#include "dma.h"


#ifdef	__cplusplus
extern "C" {
#endif
// Объявление 16-битных цветов 
typedef enum {
        BLACK             = 0x0000, //0000000000000000
        WHITE             = 0xFFFF, //1111111111111111
        BRIGHTBLUE        = 0x001F, //0000000000011111
        BRIGHTGREEN       = 0x07E0, //0000011111100000
        BRIGHTCYAN        = 0x07FF, //0000011111111111
        BRIGHTRED         = 0xF800, //1111100000000000
        BRIGHTMAGENTA     = 0xF81F, //1111100000011111
        BRIGHTYELLOW      = 0xFFE0, //1111111111100000
        BLUE              = 0x0010, //0000000000010000
        GREEN             = 0x0400, //0000010000000000
        CYAN              = 0x0410, //0000010000010000
        RED               = 0x8000  //1000000000000000
        
}COLOR;
    
#define FRAME_ADDR  0x80000000 //Начальный адрес SDRAM для записи выводимого кадра
//Данные регистрируются по заднему фронту, значит актуально ограничение DIV ≥ 5
#define DIV_VCLKO_OUT 5        //Делитель частоты для частоты пиксельной синхронизации
    
void VPOUT_Init(unsigned int _div_VCLKO_out, //Fc   Freq_VCLKO_out = 240*1e6/_div_VCLKO_out
                unsigned int _hstart,        //Hstart - количество тактов VCLKO_out(пиксельной синхронизации), при которых HSYNC_out = 0
                unsigned int _hend,          //Период сигнала HSYNC_out в размерности пиксельной синхронизации; Th = HEND*Tc (где Tc - период VCLKO_out)
                unsigned int _vstart,        //VSTART - количество тактов HSYNC_out(строчной синхронизации), при которых VSYNC_out = 0
                unsigned int _vend,          //Период сигнала VSYNC_out в размерности строчной синхронизации; Tv = VEND*Th (где Th - период HSYNC_out)
                unsigned int _frame_addr,    //Адрес памяти, который хранит видеокадр
                unsigned int _frame_len      //Длина кадра в пикселях
                
);

void VPOUT_Snapshot(unsigned int _enable);

void VPOUT_Start(unsigned int _enable);

#ifdef	__cplusplus
}
#endif

#endif //_VPOUT_H_
