﻿// dma.h
//Файл реализует интефрейс для работы с цепочками самоинициализации DMA

#ifndef _DMA_H_
#define _DMA_H_

#include "memory_nvcom02_t.h"

#ifdef __cplusplus
extern "C" {
#endif

// Звено цепочки самоинициализации DMA
typedef struct {
  unsigned int _Reserved;
  unsigned int _IR;
  unsigned int _CP;
  unsigned int _CSR;
} __attribute__((aligned(8))) ChainDmaPort;

unsigned int sys_kernel_va_to_pa(unsigned int va);

void DMA_Configure_chain(
    ChainDmaPort *_current, //Указатель на структуру текущего звена
    ChainDmaPort *_next, //Указатель на структуру следующего звена
    unsigned int _run,   //Бит RUN, запуск звена
    unsigned int _im,    //Бит IM, разрещающий прерывание по завершению звена
    unsigned int _chen,  //Бит CHEN, разрешение дальнейшей самоинициализации
    unsigned int *_data, //Адрес данных для передачи
    unsigned int _size); //Размер массива данных

void DMA_Load_chain(ChainDmaPort *_first );       //Указатель на первое звено цепочки
#ifdef	__cplusplus
}
#endif

#endif //_DMA_H_
