/*******************************************************************************
						memory_nvcom02_t.h

      NVCom02T.
   ,  
   NVCom02T  ,    .

********************************************************************************

04.10.2012 :  MCC

*******************************************************************************/

#ifndef MEMORY_NVCOM02_T_H
#define MEMORY_NVCOM02_T_H

//TYPES
#ifndef uint
   #define uint unsigned int
#endif

/*******************************************************************************
	  CPU - CRAM: 0xB8000000 - 0xB801FFFF
*******************************************************************************/

#define BASE_CRAM        0xB8000000

/*******************************************************************************
	 CPU: 0xB82F0000 - 0xB82FFFFF
*******************************************************************************/

//*******  DMA_MEM_CH

//MemCh0
#define	CSR_MEM_CH0		*((volatile uint *)0xB82F0000)
#define	CP_MEM_CH0		*((volatile uint *)0xB82F0004)
#define	IR0_MEM_CH0		*((volatile uint *)0xB82F0008)
#define	IR1_MEM_CH0		*((volatile uint *)0xB82F000C)
#define	OR_MEM_CH0		*((volatile uint *)0xB82F0010)
#define	Y_MEM_CH0		*((volatile uint *)0xB82F0014)
#define	RUN_MEM_CH0		*((volatile uint *)0xB82F0018)
//MemCh1
#define	CSR_MEM_CH1		*((volatile uint *)0xB82F0080)
#define	CP_MEM_CH1		*((volatile uint *)0xB82F0084)
#define	IR0_MEM_CH1		*((volatile uint *)0xB82F0088)
#define	IR1_MEM_CH1		*((volatile uint *)0xB82F008C)
#define	OR_MEM_CH1		*((volatile uint *)0xB82F0090)
#define	Y_MEM_CH1		*((volatile uint *)0xB82F0094)
#define	RUN_MEM_CH1		*((volatile uint *)0xB82F0098)
//MemCh2
#define	CSR_MEM_CH2		*((volatile uint *)0xB82F0100)
#define	CP_MEM_CH2		*((volatile uint *)0xB82F0104)
#define	IR0_MEM_CH2		*((volatile uint *)0xB82F0108)
#define	IR1_MEM_CH2		*((volatile uint *)0xB82F010C)
#define	OR_MEM_CH2		*((volatile uint *)0xB82F0110)
#define	Y_MEM_CH2		*((volatile uint *)0xB82F0114)
#define	RUN_MEM_CH2		*((volatile uint *)0xB82F0118)
//MemCh3
#define	CSR_MEM_CH3		*((volatile uint *)0xB82F0180)
#define	CP_MEM_CH3		*((volatile uint *)0xB82F0184)
#define	IR0_MEM_CH3		*((volatile uint *)0xB82F0188)
#define	IR1_MEM_CH3		*((volatile uint *)0xB82F018C)
#define	OR_MEM_CH3		*((volatile uint *)0xB82F0190)
#define	Y_MEM_CH3		*((volatile uint *)0xB82F0194)
#define	RUN_MEM_CH3		*((volatile uint *)0xB82F0198)

//*******  DMA VPIN_CH

#define	CSR_VPIN_CH		*((volatile uint *)0xB82F8800)
#define	CP_VPIN_CH		*((volatile uint *)0xB82F8804)
#define	IR_VPIN_CH		*((volatile uint *)0xB82F8808)
#define	OR_VPIN_CH		*((volatile uint *)0xB82F880C)
#define	Y_VPIN_CH		*((volatile uint *)0xB82F8810)
#define	RUN_VPIN_CH		*((volatile uint *)0xB82F8814)

//*******  DMA VPOUT_CH

#define	CSR_VPOUT_CH	*((volatile uint *)0xB82F9800)
#define	CP_VPOUT_CH		*((volatile uint *)0xB82F9804)
#define	IR_VPOUT_CH		*((volatile uint *)0xB82F9808)
#define	OR_VPOUT_CH		*((volatile uint *)0xB82F980C)
#define	Y_VPOUT_CH		*((volatile uint *)0xB82F9810)
#define	RUN_VPOUT_CH	*((volatile uint *)0xB82F9814)

//*******  DMA EMAC_CH

//EMACCh0
#define	CSR_EMAC_CH0	*((volatile uint *)0xB82FE800)
#define	CP_EMAC_CH0		*((volatile uint *)0xB82FE804)
#define	IR_EMAC_CH0		*((volatile uint *)0xB82FE808)
#define	RUN_EMAC_CH0	*((volatile uint *)0xB82FE814)
//EMACCh1
#define	CSR_EMAC_CH1	*((volatile uint *)0xB82FE840)
#define	CP_EMAC_CH1		*((volatile uint *)0xB82FE844)
#define	IR_EMAC_CH1		*((volatile uint *)0xB82FE848)
#define	RUN_EMAC_CH1	*((volatile uint *)0xB82FE854)

//*******  DMA MFBSP_RX_CH

//MFBSP_RX_Ch0
#define	CSR_MFBSP_RX_CH0	*((volatile uint *)0xB82F7800)
#define	CP_MFBSP_RX_CH0		*((volatile uint *)0xB82F7804)
#define	IR_MFBSP_RX_CH0		*((volatile uint *)0xB82F7808)
#define	RUN_MFBSP_RX_CH0	*((volatile uint *)0xB82F780C)
//MFBSP_RX_Ch1
#define	CSR_MFBSP_RX_CH1	*((volatile uint *)0xB82F7840)
#define	CP_MFBSP_RX_CH1		*((volatile uint *)0xB82F7844)
#define	IR_MFBSP_RX_CH1		*((volatile uint *)0xB82F7848)
#define	RUN_MFBSP_RX_CH1	*((volatile uint *)0xB82F784C)
//MFBSP_RX_Ch2
#define	CSR_MFBSP_RX_CH2	*((volatile uint *)0xB82F7880)
#define	CP_MFBSP_RX_CH2		*((volatile uint *)0xB82F7884)
#define	IR_MFBSP_RX_CH2		*((volatile uint *)0xB82F7888)
#define	RUN_MFBSP_RX_CH2	*((volatile uint *)0xB82F788C)
//MFBSP_RX_Ch3
#define	CSR_MFBSP_RX_CH3	*((volatile uint *)0xB82F78C0)
#define	CP_MFBSP_RX_CH3		*((volatile uint *)0xB82F78C4)
#define	IR_MFBSP_RX_CH3		*((volatile uint *)0xB82F78C8)
#define	RUN_MFBSP_RX_CH3	*((volatile uint *)0xB82F78CC)

//*******  DMA MFBSP_TX_Ch

//MFBSP_TX_Ch0
#define	CSR_MFBSP_TX_CH0	*((volatile uint *)0xB82F7C00)
#define	CP_MFBSP_TX_CH0		*((volatile uint *)0xB82F7C04)
#define	IR_MFBSP_TX_CH0		*((volatile uint *)0xB82F7C08)
#define	RUN_MFBSP_TX_CH0	*((volatile uint *)0xB82F7C0C)
//MFBSP_TX_Ch1
#define	CSR_MFBSP_TX_CH1	*((volatile uint *)0xB82F7C40)
#define	CP_MFBSP_TX_CH1		*((volatile uint *)0xB82F7C44)
#define	IR_MFBSP_TX_CH1		*((volatile uint *)0xB82F7C48)
#define	RUN_MFBSP_TX_CH1	*((volatile uint *)0xB82F7C4C)
//MFBSP_TX_Ch2
#define	CSR_MFBSP_TX_CH2	*((volatile uint *)0xB82F7C80)
#define	CP_MFBSP_TX_CH2		*((volatile uint *)0xB82F7C84)
#define	IR_MFBSP_TX_CH2		*((volatile uint *)0xB82F7C88)
#define	RUN_MFBSP_TX_CH2	*((volatile uint *)0xB82F7C8C)
//MFBSP_TX_Ch3
#define	CSR_MFBSP_TX_CH3	*((volatile uint *)0xB82F7CC0)
#define	CP_MFBSP_TX_CH3		*((volatile uint *)0xB82F7CC4)
#define	IR_MFBSP_TX_CH3		*((volatile uint *)0xB82F7CC8)
#define	RUN_MFBSP_TX_CH3	*((volatile uint *)0xB82F7CCC)

//*******  I2C

#define	PRER_I2C		*((volatile uint *)0xB82F2000)
#define	CTR_I2C			*((volatile uint *)0xB82F2004)
#define	TXR_I2C			*((volatile uint *)0xB82F2008)
#define	RXR_I2C			*((volatile uint *)0xB82F200C)
#define	CR_I2C			*((volatile uint *)0xB82F2010)
#define	SR_I2C			*((volatile uint *)0xB82F2014)
#define	PR_CNT_I2C      *((volatile uint *)0xB82F2018)

//*******  UART0

#define	RBR_UART0		*((volatile uint *)0xB82F3000)
#define	THR_UART0		*((volatile uint *)0xB82F3000)
#define	IER_UART0		*((volatile uint *)0xB82F3004)
#define	IIR_UART0		*((volatile uint *)0xB82F3008)
#define	FCR_UART0		*((volatile uint *)0xB82F3008)
#define	LCR_UART0		*((volatile uint *)0xB82F300C)
#define	MCR_UART0		*((volatile uint *)0xB82F3010)
#define	LSR_UART0		*((volatile uint *)0xB82F3014)
#define	MSR_UART0		*((volatile uint *)0xB82F3018)
#define	SPR_UART0		*((volatile uint *)0xB82F301C)
#define	DLL_UART0		*((volatile uint *)0xB82F3000)
#define	DLM_UART0		*((volatile uint *)0xB82F3004)
#define	SCLR_UART0		*((volatile uint *)0xB82F3014)

//*******  UART1

#define	RBR_UART1		*((volatile uint *)0xB82F3800)
#define	THR_UART1		*((volatile uint *)0xB82F3800)
#define	IER_UART1		*((volatile uint *)0xB82F3804)
#define	IIR_UART1		*((volatile uint *)0xB82F3808)
#define	FCR_UART1		*((volatile uint *)0xB82F3808)
#define	LCR_UART1		*((volatile uint *)0xB82F380C)
#define	MCR_UART1		*((volatile uint *)0xB82F3810)
#define	LSR_UART1		*((volatile uint *)0xB82F3814)
#define	MSR_UART1		*((volatile uint *)0xB82F3818)
#define	SPR_UART1		*((volatile uint *)0xB82F381C)
#define	DLL_UART1		*((volatile uint *)0xB82F3800)
#define	DLM_UART1		*((volatile uint *)0xB82F3804)
#define	SCLR_UART1		*((volatile uint *)0xB82F3814)

//*******  IT0

#define	ITCSR0			*((volatile uint *)0xB82FD000)
#define	ITPERIOD0		*((volatile uint *)0xB82FD004)
#define	ITCOUNT0		*((volatile uint *)0xB82FD008)
#define	ITSCALE0		*((volatile uint *)0xB82FD00C)

//*******  WDT

#define	WTCSR			*((volatile uint *)0xB82FD010)
#define	WTPERIOD		*((volatile uint *)0xB82FD014)
#define	WTCOUNT			*((volatile uint *)0xB82FD018)
#define	WTSCALE			*((volatile uint *)0xB82FD01C)

//*******  IT1

#define	ITCSR1			*((volatile uint *)0xB82FD020)
#define	ITPERIOD1		*((volatile uint *)0xB82FD024)
#define	ITCOUNT1		*((volatile uint *)0xB82FD028)
#define	ITSCALE1		*((volatile uint *)0xB82FD02C)

//*******  MFBSP0

#define	TX_MFBSP0		*((volatile uint *)0xB82F7000)
#define	RX_MFBSP0		*((volatile uint *)0xB82F7000)
#define	CSR_MFBSP0		*((volatile uint *)0xB82F7004)
#define	DIR_MFBSP0		*((volatile uint *)0xB82F7008)
#define	GPIO_DR0		*((volatile uint *)0xB82F700C)
#define	TCTR0			*((volatile uint *)0xB82F7010)
#define	RCTR0			*((volatile uint *)0xB82F7014)
#define	TSR0			*((volatile uint *)0xB82F7018)
#define	RSR0			*((volatile uint *)0xB82F701C)
#define	TCTR_RATE0		*((volatile uint *)0xB82F7020)
#define	RCTR_RATE0		*((volatile uint *)0xB82F7024)

//*******  MFBSP1

#define	TX_MFBSP1		*((volatile uint *)0xB82F7100)
#define	RX_MFBSP1		*((volatile uint *)0xB82F7100)
#define	CSR_MFBSP1		*((volatile uint *)0xB82F7104)
#define	DIR_MFBSP1		*((volatile uint *)0xB82F7108)
#define	GPIO_DR1		*((volatile uint *)0xB82F710C)
#define	TCTR1			*((volatile uint *)0xB82F7110)
#define	RCTR1			*((volatile uint *)0xB82F7114)
#define	TSR1			*((volatile uint *)0xB82F7118)
#define	RSR1			*((volatile uint *)0xB82F711C)
#define	TCTR_RATE1		*((volatile uint *)0xB82F7120)
#define	RCTR_RATE1		*((volatile uint *)0xB82F7124)

//*******  MFBSP2

#define	TX_MFBSP2		*((volatile uint *)0xB82F7200)
#define	RX_MFBSP2		*((volatile uint *)0xB82F7200)
#define	CSR_MFBSP2		*((volatile uint *)0xB82F7204)
#define	DIR_MFBSP2		*((volatile uint *)0xB82F7208)
#define	GPIO_DR2		*((volatile uint *)0xB82F720C)
#define	TCTR2			*((volatile uint *)0xB82F7210)
#define	RCTR2			*((volatile uint *)0xB82F7214)
#define	TSR2			*((volatile uint *)0xB82F7218)
#define	RSR2			*((volatile uint *)0xB82F721C)
#define	TCTR_RATE2		*((volatile uint *)0xB82F7220)
#define	RCTR_RATE2		*((volatile uint *)0xB82F7224)

//*******  MFBSP3

#define	TX_MFBSP3		*((volatile uint *)0xB82F7300)
#define	RX_MFBSP3		*((volatile uint *)0xB82F7300)
#define	CSR_MFBSP3		*((volatile uint *)0xB82F7304)
#define	DIR_MFBSP3		*((volatile uint *)0xB82F7308)
#define	GPIO_DR3		*((volatile uint *)0xB82F730C)
#define	TCTR3			*((volatile uint *)0xB82F7310)
#define	RCTR3			*((volatile uint *)0xB82F7314)
#define	TSR3			*((volatile uint *)0xB82F7318)
#define	RSR3			*((volatile uint *)0xB82F731C)
#define	TCTR_RATE3		*((volatile uint *)0xB82F7320)
#define	RCTR_RATE3		*((volatile uint *)0xB82F7324)

//*******  VPIN

#define	CSR_VPIN			*((volatile uint *)0xB82F8000)
#define	LinePix_cnt_VPIN	*((volatile uint *)0xB82F8004)
#define	Frame_cnt_VPIN		*((volatile uint *)0xB82F8008)
#define	FIFO_OUT_VPIN		*((volatile uint *)0xB82F800C)

//*******  VPOUT

#define	CSR_VPOUT			*((volatile uint *)0xB82F9000)
#define	DIV_VPOUT			*((volatile uint *)0xB82F9004)
#define	HstartHend_VPOUT	*((volatile uint *)0xB82F9008)
#define	VstartVend_VPOUT	*((volatile uint *)0xB82F900C)
#define	LinePix_cnt_VPOUT	*((volatile uint *)0xB82F9010)
#define	Frame_cnt_VPOUT		*((volatile uint *)0xB82F9014)
#define	FIFO_IN_VPOUT		*((volatile uint *)0xB82F901C)

//*******  Ethernet MAC

#define	MAC_CONTROL			*((volatile uint *)0xB82FE000)
#define	MAC_ADDR_L			*((volatile uint *)0xB82FE004)
#define	MAC_ADDR_H			*((volatile uint *)0xB82FE008)
#define	DADDR_L				*((volatile uint *)0xB82FE00C)
#define	DADDR_H				*((volatile uint *)0xB82FE010)
#define	FCS_CLIENT			*((volatile uint *)0xB82FE014)
#define	TYPE				*((volatile uint *)0xB82FE018)
#define	IFS_COLL_MODE		*((volatile uint *)0xB82FE01C)
#define	TX_FRAME_CONTROL	*((volatile uint *)0xB82FE020)
#define	STATUS_TX			*((volatile uint *)0xB82FE024)
#define	UCADDR_L			*((volatile uint *)0xB82FE028)
#define	UCADDR_H			*((volatile uint *)0xB82FE02C)
#define	MCADDR_L			*((volatile uint *)0xB82FE030)
#define	MCADDR_H			*((volatile uint *)0xB82FE034)
#define	MCADDR_MASK_L		*((volatile uint *)0xB82FE038)
#define	MCADDR_MASK_H		*((volatile uint *)0xB82FE03C)
#define	HASHT_L				*((volatile uint *)0xB82FE040)
#define	HASHT_H				*((volatile uint *)0xB82FE044)
#define	RX_FRAME_CONTROL	*((volatile uint *)0xB82FE048)
#define	RX_FR_MaxSize		*((volatile uint *)0xB82FE04C)
#define	STATUS_RX			*((volatile uint *)0xB82FE050)
#define	RX_FRAME_STATUS_FIFO	*((volatile uint *)0xB82FE054)
#define	MD_CONTROL			*((volatile uint *)0xB82FE058)
#define	MD_STATUS			*((volatile uint *)0xB82FE05C)
#define	MD_MODE				*((volatile uint *)0xB82FE060)
#define	TX_TEST_CSR			*((volatile uint *)0xB82FE064)
#define	TX_FIFO				*((volatile uint *)0xB82FE068)
#define	RX_TEST_CSR			*((volatile uint *)0xB82FE06C)
#define	RX_FIFO				*((volatile uint *)0xB82FE070)

//*******  MPORT

#define	CSCON0				*((volatile uint *)0xB82F1000)
#define	CSCON1				*((volatile uint *)0xB82F1004)
#define	CSCON2				*((volatile uint *)0xB82F1008)
#define	CSCON3				*((volatile uint *)0xB82F100C)
#define	CSCON4				*((volatile uint *)0xB82F1010)
#define	SDRCON				*((volatile uint *)0xB82F1014)
#define	SDRTMR				*((volatile uint *)0xB82F1018)
#define	SDRCSR				*((volatile uint *)0xB82F101C)

//*******  

#define	CR_PLL				*((volatile uint *)0xB82F4000)
#define	CLK_EN				*((volatile uint *)0xB82F4004)
#define	CSR					*((volatile uint *)0xB82F4008)
#define	MASKR0				*((volatile uint *)0xB82F4010)
#define	QSTR0				*((volatile uint *)0xB82F4014)
#define	MASKR1				*((volatile uint *)0xB82F4018)
#define	QSTR1				*((volatile uint *)0xB82F401C)
#define	MASKR2				*((volatile uint *)0xB82F4020)
#define	QSTR2				*((volatile uint *)0xB82F4024)
#define	IRQM				*((volatile uint *)0xB82F4030)

/*******************************************************************************
					 MCC: 0xB82F_F000 - 0xB82F_FFFC
*******************************************************************************/
#define	BASE_MCC_REGS		0xB82FF000
#define	MCC_REGS_A (i)		(*((volatile uint *) (BASE_MCC_REGS  +  i)))

//  
#define	MCC_VERSION			MCC_REGS_A (0x000)
#define	MCC_TEST_RW			MCC_REGS_A (0x004)
#define	MCC_TEST_CFG		MCC_REGS_A (0x008)
//  
#define	MCC_TB_MS_CODE		MCC_REGS_A (0x010)
//   
#define	MCC_PPS_MS			MCC_REGS_A (0x014)
#define	MCC_PPS_OFS			MCC_REGS_A (0x018)
//  
#define	MCC_ADC_GP1_I		MCC_REGS_A (0x02C)
#define	MCC_ADC_GP1_Q		MCC_REGS_A (0x030)
#define	MCC_ADC_GL1_I		MCC_REGS_A (0x03C)
#define	MCC_ADC_GL1_Q		MCC_REGS_A (0x040)
#define	MCC_ADC_GL2_I		MCC_REGS_A (0x044)
#define	MCC_ADC_GL2_Q		MCC_REGS_A (0x048)
#define	MCC_ADC_CTRL		MCC_REGS_A (0x04C)
//  GPS/GLONASS
#define	MCC_IMIT_FCHIP		MCC_REGS_A (0x050)
#define	MCC_IMIT_PCHIP		MCC_REGS_A (0x054)
#define	MCC_IMIT_FDOP		MCC_REGS_A (0x058)
#define	MCC_IMIT_G1G2		MCC_REGS_A (0x05C)
#define	MCC_IMIT_CFG		MCC_REGS_A (0x060)
#define	MCC_IMIT_KN			MCC_REGS_A (0x064)
//   
#define	MCC_GGM_CHIP		MCC_REGS_A (0x074)
#define	MCC_GGM_GPS			MCC_REGS_A (0x078)
#define	MCC_GGM_GLO			MCC_REGS_A (0x07C)
//   
#define	MCC_RFD_CFG			MCC_REGS_A (0x080)
#define	MCC_RFD_FHET		MCC_REGS_A (0x084)
#define	MCC_RFD_FDUMP		MCC_REGS_A (0x088)
#define	MCC_RFD_DATA		MCC_REGS_A (0x08C)
//     FSE
#define	MCC_FSE_CHMSK		MCC_REGS_A (0x090)
#define	MCC_FSE_PRSIN		MCC_REGS_A (0x094)
//  
#define	MCC_ECNT			MCC_REGS_A (0x09C)
//  
#define	MCC_IRQ_CFG			MCC_REGS_A (0x0A0)
#define	MCC_IRQ_MASK_CA6	MCC_REGS_A (0x0A4)
#define	MCC_IRQ_MASK_FSE	MCC_REGS_A (0x0A8)
#define	MCC_IRQ_STAT		MCC_REGS_A (0x0AC)
#define	MCC_IRQ_STAT_CA6	MCC_REGS_A (0x0B0)
#define	MCC_IRQ_STAT_FSE	MCC_REGS_A (0x0B4)
#define	MCC_IRQ_ACK			MCC_REGS_A (0x0B8)
#define	MCC_IRQ_ACK_CA6		MCC_REGS_A (0x0BC)
#define	MCC_IRQ_ACK_FSE		MCC_REGS_A (0x0C0)

//     .

#define	MCC_FSE_0			MCC_REGS_A (0x400)
#define	MCC_FSE_1			MCC_REGS_A (0x440)
#define	MCC_FSE_2			MCC_REGS_A (0x480)
#define	MCC_FSE_3			MCC_REGS_A (0x4C0)

//    
//  CA6, i = 0...23

#define	BASE_MCC_CA6C(i)	(0x600  +  (i)*0x20)

//    
//  CA/CT, i = 0...15

#define	BASE_MCC_CAC(i)		(0x900  +  (i)*0x20)

//     (R/W)
//  CA6, i = 0...23

#define	BASE_MCC_CA6D(i)	(0xB00  +  (i)*0x20)

//     (R/W)
//  CA/CT, i = 0...15

#define	BASE_MCC_CAD(i)		(0xE00  +  (i)*0x8)

//   CA/CT, i = 0...15
#define	MCC_CA_FCHIP(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x000)
#define	MCC_CA_PCHIP(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x004)
#define	MCC_CA_FHET(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x008)
#define	MCC_CA_WEML(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x00C)
#define	MCC_CA_CFG(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x010)
#define	MCC_CA_PHET(i)		MCC_REGS_A (BASE_MCC_CAC(i) + 0x018)
//   CA/CT, i = 0...15
#define	MCC_CA_PROMPT(i)	MCC_REGS_A (BASE_MCC_CAD(i) + 0x000)
#define	MCC_CA_EML(i)		MCC_REGS_A (BASE_MCC_CAD(i) + 0x004)

//   CA6, i = 0...23
#define	MCC_CA6_FCHIP(i)	MCC_REGS_A (BASE_MCC_CA6C(i) + 0x000)
#define	MCC_CA6_PCHIP(i)	MCC_REGS_A (BASE_MCC_CA6C(i) + 0x004)
#define	MCC_CA6_FHET(i)		MCC_REGS_A (BASE_MCC_CA6C(i) + 0x008)
#define	MCC_CA6_CFG2(i)		MCC_REGS_A (BASE_MCC_CA6C(i) + 0x00C)
#define	MCC_CA6_CFG(i)		MCC_REGS_A (BASE_MCC_CA6C(i) + 0x010)
#define	MCC_CA6_ACCTIME(i)	MCC_REGS_A (BASE_MCC_CA6C(i) + 0x014)
#define	MCC_CA6_PHET(i)		MCC_REGS_A (BASE_MCC_CA6C(i) + 0x018)
#define	MCC_CA6_SPC(i)		MCC_REGS_A (BASE_MCC_CA6C(i) + 0x01C)
//   CA6
#define	MCC_CA6_ACC0(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x000)
#define	MCC_CA6_ACC1(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x004)
#define	MCC_CA6_ACC2(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x008)
#define	MCC_CA6_ACC3(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x00C)
#define	MCC_CA6_ACC4(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x010)
#define	MCC_CA6_ACC5(i)		MCC_REGS_A (BASE_MCC_CA6D(i) + 0x014)

/*******************************************************************************
					  DSP
*******************************************************************************/

#define BASE_DSP_XYRAM0    	0xB8400000
#define BASE_DSP_XYRAM1    	0xB8800000
#define BASE_DSP_PRAM0      0xB8440000
#define BASE_DSP_PRAM1      0xB8840000

/*******************************************************************************
					 DSP
*******************************************************************************/

//*******     

#define MASKR_DSP	        *((volatile uint *)0xb8481000)
#define QSTR_DSP	        *((volatile uint *)0xb8481004)
#define CSR_DSP		        *((volatile uint *)0xb8481008)
#define TOTAL_CLK_CNTR      *((volatile uint *)0xb848100C)

//*******    XBUF

#define X0_L		        *((volatile uint *)0xb87FFF00)
#define X0_H		        *((volatile uint *)0xb87FFF04)
#define X1_L		        *((volatile uint *)0xb87FFF08)
#define X1_H		        *((volatile uint *)0xb87FFF0C)
#define X2_L		        *((volatile uint *)0xb87FFF10)
#define X2_H		        *((volatile uint *)0xb87FFF14)
#define X3_L		        *((volatile uint *)0xb87FFF18)
#define X3_H		        *((volatile uint *)0xb87FFF1C)
#define X4_L		        *((volatile uint *)0xb87FFF20)
#define X4_H		        *((volatile uint *)0xb87FFF24)
#define X5_L		        *((volatile uint *)0xb87FFF28)
#define X5_H		        *((volatile uint *)0xb87FFF2C)
#define X6_L		        *((volatile uint *)0xb87FFF30)
#define X6_H		        *((volatile uint *)0xb87FFF34)
#define X7_L		        *((volatile uint *)0xb87FFF38)
#define X7_H		        *((volatile uint *)0xb87FFF3C)
#define X8_L		        *((volatile uint *)0xb87FFF40)
#define X8_H		        *((volatile uint *)0xb87FFF44)
#define X9_L		        *((volatile uint *)0xb87FFF48)
#define X9_H		        *((volatile uint *)0xb87FFF4C)
#define X10_L		        *((volatile uint *)0xb87FFF50)
#define X10_H		        *((volatile uint *)0xb87FFF54)
#define X11_L		        *((volatile uint *)0xb87FFF58)
#define X11_H		        *((volatile uint *)0xb87FFF5C)
#define X12_L		        *((volatile uint *)0xb87FFF60)
#define X12_H		        *((volatile uint *)0xb87FFF64)
#define X13_L		        *((volatile uint *)0xb87FFF68)
#define X13_H		        *((volatile uint *)0xb87FFF6C)
#define X14_L		        *((volatile uint *)0xb87FFF70)
#define X14_H		        *((volatile uint *)0xb87FFF74)
#define X15_L		        *((volatile uint *)0xb87FFF78)
#define X15_H		        *((volatile uint *)0xb87FFF7C)
#define X16_L		        *((volatile uint *)0xb87FFF80)
#define X16_H		        *((volatile uint *)0xb87FFF84)
#define X17_L		        *((volatile uint *)0xb87FFF88)
#define X17_H		        *((volatile uint *)0xb87FFF8C)
#define X18_L		        *((volatile uint *)0xb87FFF90)
#define X18_H		        *((volatile uint *)0xb87FFF94)
#define X19_L		        *((volatile uint *)0xb87FFF98)
#define X19_H		        *((volatile uint *)0xb87FFF9C)
#define X20_L		        *((volatile uint *)0xb87FFFA0)
#define X20_H		        *((volatile uint *)0xb87FFFA4)
#define X21_L		        *((volatile uint *)0xb87FFFA8)
#define X21_H		        *((volatile uint *)0xb87FFFAC)
#define X22_L		        *((volatile uint *)0xb87FFFB0)
#define X22_H		        *((volatile uint *)0xb87FFFB4)
#define X23_L		        *((volatile uint *)0xb87FFFB8)
#define X23_H		        *((volatile uint *)0xb87FFFBC)
#define X24_L		        *((volatile uint *)0xb87FFFC0)
#define X24_H		        *((volatile uint *)0xb87FFFC4)
#define X25_L		        *((volatile uint *)0xb87FFFC8)
#define X25_H		        *((volatile uint *)0xb87FFFCC)
#define X26_L		        *((volatile uint *)0xb87FFFD0)
#define X26_H		        *((volatile uint *)0xb87FFFD4)
#define X27_L		        *((volatile uint *)0xb87FFFD8)
#define X27_H		        *((volatile uint *)0xb87FFFDC)
#define X28_L		        *((volatile uint *)0xb87FFFE0)
#define X28_H		        *((volatile uint *)0xb87FFFE4)
#define X29_L		        *((volatile uint *)0xb87FFFE8)
#define X29_H		        *((volatile uint *)0xb87FFFEC)
#define X30_L		        *((volatile uint *)0xb87FFFF0)
#define X30_H		        *((volatile uint *)0xb87FFFF4)
#define X31_L		        *((volatile uint *)0xb87FFFF8)
#define X31_H		        *((volatile uint *)0xb87FFFFC)

//   DSP, i = 0, 1

#define BASE_DSP_REGS(i)	(0xB8480000 + (i)*0x400000)

//*******  PCU

#define DCSR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0100))
#define SR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0104))
#define IDR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0108))
#define EFR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x010C))
#define DSTART(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x010C))
#define IRQR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0110))
#define IMASKR(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0114))
#define TMR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0118))
#define ARBR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x011C))
#define PC(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0120))
#define SS(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0124))
#define LA(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0128))
#define CSL(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x012C))
#define LC(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0130))
#define CSH(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0134))
#define SP(i) 		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0138))
#define SAR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x013C))
#define CNTR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0140))
#define SAR1(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0144))
#define SAR2(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0148))
#define SAR3(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x014C))
#define SAR4(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0150))
#define SAR5(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0154))
#define SAR6(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0158))
#define SAR7(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x015C))

//*******   ALU

#define CCR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0160))
#define PDNR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0164))
#define SFR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0168))

#define QMASKR0(i)		    *((volatile uint *) (BASE_DSP_REGS(i) + 0x0170))
#define QMASKR1(i)		    *((volatile uint *) (BASE_DSP_REGS(i) + 0x0174))
#define QMASKR2(i)		    *((volatile uint *) (BASE_DSP_REGS(i) + 0x0178))

//*******    AGU, AGU-Y

#define A0(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0080))
#define A1(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0084))
#define A2(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0088))
#define A3(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x008C))
#define A4(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0090))
#define A5(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0094))
#define A6(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0098))
#define A7(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x009C))
#define I0(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00A0))
#define I1(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00A4))
#define I2(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00A8))
#define I3(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00AC))
#define I4(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00B0))
#define I5(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00B4))
#define I6(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00B8))
#define I7(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00BC))
#define M0(i)	        	*((volatile uint *) (BASE_DSP_REGS(i) + 0x00C0))
#define M1(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00C4))
#define M2(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00C8))
#define M3(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00CC))
#define M4(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00D0))
#define M5(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00D4))
#define M6(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00D8))
#define M7(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00DC))
#define AT(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00E0))
#define IT(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00E4))
#define MT(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00E8))
#define DT(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00EC))
#define IVAR(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x00FC))

//*******   RF

#define R0_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0000))
#define R2_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0004))
#define R4_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0008))
#define R6_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x000C))
#define R8_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0010))
#define R10_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0014))
#define R12_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0018))
#define R14_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x001C))
#define R16_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0020))
#define R18_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0024))
#define R20_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0028))
#define R22_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x002C))
#define R24_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0030))
#define R26_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0034))
#define R28_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0038))
#define R30_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x003C))
#define R1_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0040))
#define R3_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0044))
#define R5_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0048))
#define R7_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x004C))
#define R9_L(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0050))
#define R11_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0054))
#define R13_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0058))
#define R15_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x005C))
#define R17_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0060))
#define R19_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0064))
#define R21_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0068))
#define R23_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x006C))
#define R25_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0070))
#define R27_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0074))
#define R29_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0078))
#define R31_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x007C))

#define R1D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0180))
#define R1D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0184))
#define R3D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0188))
#define R3D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x018C))
#define R5D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0190))
#define R5D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0194))
#define R7D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0198))
#define R7D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x019C))
#define R9D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01A0))
#define R9D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01A4))
#define R11D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01A8))
#define R11D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01AC))
#define R13D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01B0))
#define R13D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01B4))
#define R15D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01B8))
#define R15D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01BC))
#define R17D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01C0))
#define R17D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01C4))
#define R19D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01C8))
#define R19D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01CC))
#define R21D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01D0))
#define R21D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01D4))
#define R23D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01D8))
#define R23D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01DC))
#define R25D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01E0))
#define R25D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01E4))
#define R27D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01E8))
#define R27D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01EC))
#define R29D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01F0))
#define R29D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01F4))
#define R31D_L(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01F8))
#define R31D_H(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x01FC))

//******* -

#define AC0(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0200))
#define AC1(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0204))
#define AC2(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0208))
#define AC3(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x020C))
#define AC4(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0210))
#define AC5(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0214))
#define AC6(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0218))
#define AC7(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x021C))
#define AC8(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0220))
#define AC9(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0224))
#define AC10(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0228))
#define AC11(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x022C))
#define AC12(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0230))
#define AC13(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0234))
#define AC14(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0238))
#define AC15(i)		        *((volatile uint *) (BASE_DSP_REGS(i) + 0x023C))

//*******  

#define dbDCSR(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0500))
#define Cnt_RUN(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0518))
#define dbPCa(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0524))
#define dbPCf(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0528))
#define dbPCd(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x052C))
#define dbPCe(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0520))
#define dbPCe1(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0530))
#define dbPCe2(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0534))
#define dbPCe3(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0538))
#define dbSAR(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x053C))
#define dbCNTR(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0540))
#define dbSAR1(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0544))
#define dbSAR2(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0548))
#define dbSAR3(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x054C))
#define dbSAR4(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0550))
#define dbSAR5(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0554))
#define dbSAR6(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x0558))
#define dbSAR7(i)	        *((volatile uint *) (BASE_DSP_REGS(i) + 0x055C))

#endif //MEMORY_NVCOM02_T_H
