﻿#ifndef _TARGET_H_
#define _TARGET_H_

#ifdef	__cplusplus
extern "C" {
#endif
//Стандартные значения для MC-LCD-TOUCH (AT070TN92)

#define WIDTH            800                                              //Количество АКТИВНЫХ писелей в строке (Ширина)
#define HEIGHT           480                                              //Количество АКТИВНЫХ строк в кадре (Длина)
    
#define HS_BLANKING      (46)                                             //Гашение HSYNC_out, перед Data Enable
#define H_START          (40)                                             //HSTART - количество тактов VCLKO_out(пиксельной синхронизации), при которых HSYNC_out = 0
#define H_AFTERSYNC      (210)                                            //Количество НЕАКТИВНЫХ пискелей в строке                                                                   
#define H_SYNC           (HS_BLANKING - H_START + WIDTH + H_AFTERSYNC)    //H_SYNC - количество тактов VCLKO_out, при которых HSYNC_out = 1;  (ОБЩЕЕ количество пикселей в строке)
#define H_END            (H_START + H_SYNC)                               //Период сигнала HSYNC_out в размерности пиксельной синхронизации;   
                                                                          //Th = H_END*Tc (где Tc - период VCLKO_out)

#define VS_BLANKING      (23)                                             //Гашение VSYNC_out, перед Data Enable
#define V_START          (20)                                             //VSTART - количество тактов HSYNC_out(строчной синхронизации), при которых VSYNC_out = 0
#define V_AFTERSYNC      (25)                                             //Количество НЕАКТИВНЫХ строк в кадре
#define V_SYNC           (VS_BLANKING - V_START + HEIGHT  + V_AFTERSYNC)  //V_SYNC - количество тактов HSYNC_out, при которых VSYNC_out = 1; (ОБЩЕЕ количество строк в кадре)
#define V_END            (V_START + V_SYNC)                               //Период сигнала VSYNC_out в размерности строчной синхронизации; Tv = V_END*Th (где Th - период HSYNC_out)

//Видеоданные поступают на выход по положительному фронту сигнала VCLKO_out
//при наличии одновременно активных (высоких) уровней HSYNC_out и VSYNC_out
#define FRAME_LEN       (H_SYNC)*(V_SYNC)         //Размер кадра в пикселях
    
#define FRAME_OFFSET    ( (VS_BLANKING - V_START )*H_SYNC + (HS_BLANKING - H_START)  ) //ОБЩЕЕ количество НЕАКТИВНЫХ пикселей в начале кадра

#ifdef	__cplusplus
}
#endif

#endif //_TARGET_H_ 
